clc;
close all;
clear all;

im = imread('lena_gray.bmp');
[ny,nx] = size(im);
ny = floor(ny/2);
nx = floor(nx/2);
% Gaussiano
[X,Y] = meshgrid(-ny:ny-1,-nx:nx-1);
D = sqrt(X.^2 + Y.^2);
D0 = 25;
mask = exp(-(D.^2)/(2*D0^2));
mask = 1 - mask;

%calcula fourier
f = fft2(im);
f = fftshift(f);

%aplica mscara
f1 = f .* mask;

%calcula inversa fourier
f1 = ifftshift(f1);
im1 = ifft2(f1);

%soma a imagem
im2 = im1 + double(im);

%exibe imagens
subplot(2,2,1); imshow(im);
subplot(2,2,2); imshow(mask);
subplot(2,2,3); imshow(uint8(im1));
subplot(2,2,4); imshow(uint8(im2));
