clc;
close all;
clear all;

im = imread('lena_ruido.bmp');
[ny,nx] = size(im);

%cra a mscara
raio = 20;
mask = zeros(ny,nx);
mask(round(ny/2),round(nx/2)) = 1;
bw = bwdist(mask);
mask(bw <= raio) = 1;

%calcula fourier
f = fft2(im);
f = fftshift(f);

%aplica mscara
f1 = f .* mask;

%calcula inversa fourier
f1 = ifftshift(f1);
im1 = ifft2(f1);

%exibe imagens
subplot(1,3,1); imshow(im);
subplot(1,3,2); imshow(mask);
subplot(1,3,3); imshow(uint8(im1));