clc;
close all;
clear all;

im = imread('lena_gray.bmp');
[ny,nx] = size(im);

%cra a mscara
raio = 20;
mask = zeros(ny,nx);
mask(round(ny/2),round(nx/2)) = 1;
bw = bwdist(mask);
mask(bw <= raio) = 1;
mask = ~mask;

%calcula fourier
f = fft2(im);
f = fftshift(f);

%aplica mscara
f1 = f .* mask;

%calcula inversa fourier
f1 = ifftshift(f1);
im1 = ifft2(f1);

%soma a imagem
im2 = im1 + double(im);

%exibe imagens
subplot(2,2,1); imshow(im);
subplot(2,2,2); imshow(mask);
subplot(2,2,3); imshow(uint8(im1));
subplot(2,2,4); imshow(uint8(im2));