clc;
close all;
clear all;

im = imread('lena_ruido.bmp');
[ny,nx] = size(im);
ny = floor(ny/2);
nx = floor(nx/2);
% Butterworth
n = 1;
[X,Y] = meshgrid(-ny:ny,-nx:nx);
D = sqrt(X.^2 + Y.^2);
D0 = 25;
mask = 1./(1 + (D./D0).^(2*n));

%calcula fourier
f = fft2(im);
f = fftshift(f);

%aplica mscara
f1 = f .* mask;

%calcula inversa fourier
f1 = ifftshift(f1);
im1 = ifft2(f1);

%soma a imagem
% im2 = im1 + double(im);

%exibe imagens
subplot(1,3,1); imshow(im);
subplot(1,3,2); imshow(mask);
subplot(1,3,3); imshow(uint8(im1));
